package com.ibm.trackntrace.actions;

import java.util.logging.Logger;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.trackntrace.forms.FormData;
import com.ibm.trackntrace.utils.Constants;


/**
 * @version 	1.0
 * @author
 */
public class UserLoginAction extends BXActionBase {

	private static final String MAIN_MENU = "GotoMainMenu";
	private static final String USER_LOGIN_PAGE = "UserLoginGetUser";
	//private static final String SHOW_SECURITY_PAGE = "UserLoginShowSecurity";

	static {
		log = Logger.getLogger(Constants.LOG_USERLOGIN);
	}
	
	protected String processUser(FormData formData, ActionErrors errors) {
		String target = null;
	    log.entering(getClass().getName(), "processUser", formData); //$NON-NLS-1$
        
	    String user = formData.getUserName();
	    if(user != null) {
	    	formData.setUserId("confirmed");
	    } else {
	    	target = "failed";
	    }
		       
        log.exiting(getClass().getName(), "processUser", "target=" + target); //$NON-NLS-1$ //$NON-NLS-2$
		return target;
	}
	
	protected ActionForward execute(ActionMapping mapping,
            FormData formData, HttpServletRequest request,
            HttpServletResponse response, ActionErrors errors)
            	throws Exception {
        ActionForward forward = new ActionForward(); // return value
        String target = null;
        String screen = formData.getScreen();
        String command = formData.getCommand();
        
        log.entering(getClass().getName(), "execute", formData); //$NON-NLS-1$

        if (command.equals("GotUser")) { //$NON-NLS-1$
        	target = processUser(formData, errors);
        	if (target == null) {
        		target = MAIN_MENU; //SHOW_SECURITY_PAGE;
        	} else {
        		target = USER_LOGIN_PAGE;
        	}
        	
        } else if (command.equals("Confirm")) { //$NON-NLS-1$
        	target = MAIN_MENU;
        	
        } else {
        	target = USER_LOGIN_PAGE;
        }
        
        if (target != null) {
        	forward = mapping.findForward(target);
        	request.setAttribute(Constants.FORM_DATA_ATTR, formData);
        } else {
        	errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError(Constants.UNKNOWN_COMMAND_4, request.getRequestURI(), screen, command, this.getClass().getName()));
        }

        log.exiting(getClass().getName(), "execute", "target=" + target + "; forward=" + forward); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
        
        // Finish with
        return (forward);
	}
}
