package com.ibm.trackntrace.forms;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

/**
 * Form bean for a Struts application.
 */
public class FormData extends ActionForm {

	private static final long serialVersionUID = -8225264406734986464L;

	private static boolean DEFAULT_DEBUG = false;
	
	private boolean debug = DEFAULT_DEBUG;

	private String station = null;
	private String printer = null;
	private String bizLocation = null;
	private String timeZoneOffset = null;
    private String screen = null;
    private String command = null;
    private String message = null;
    private String userName = null;
    private String userId = null;
    
    private String destinationId = null;
    private String disposition = null;
    
    private String serialNumber = null;
    private String epcUrn = null;
    private String palletTag = null;
    private String palletUrn = null;
    private String caseTag = null;
    private String caseUrn = null;
    private String unitTag = null;
    private String unitUrn = null;
    private String orderNumber = null;
    private String lastOrderNum = null;
    private int caseCount = 0;
    private int unitCount = 0;
    private int childCount = 0;
    private int palletNum = 0;
    private int palletCnt = 0;

 	private int numTagsScanned = 0;
	private boolean needTagCounter = false;
	
	//desktopAdmin section
	private String prod_code = null;
	private String prod_name = null;
	private String prod_version = null;
	private String prod_updateTime = null;
	
	private String label_type = null;
	private String label_display = null;
	private String label_updateTime = null;
	
	private String temp_name = null;
	private String temp_version = null;
	private String temp_updateTime = null;
	private String temp_label1 = null;
	private String temp_label2 = null;
	private String temp_label3 = null;
	private String temp_label4 = null;
	private String temp_label5 = null;
	private String temp_label6 = null;
	private String temp_label7 = null;
	private String temp_label8 = null;
	private String temp_label9 = null;
	
	private String req_url = null;
	
	//end of desktopAdmin section
	private String displayData = null;
	private String lastError = null;

	private String[] tagList = null;

    public String toString() {
    	String result = "FormData {Debug=" + debug + //$NON-NLS-1$
				"; station=" + station + //$NON-NLS-1$
				"; printer=" + printer + //$NON-NLS-1$
				"; screen=" + screen + //$NON-NLS-1$
				"; bizLocation=" + bizLocation + //$NON-NLS-1$
				"; timeZoneOffset=" + timeZoneOffset + //$NON-NLS-1$
				"; command=" + command + //$NON-NLS-1$
				"; message=" + message + //$NON-NLS-1$
				"; userName=" + userName + //$NON-NLS-1$
				"; userId=" + userId + //$NON-NLS-1$
				"; destinationId=" + destinationId + //$NON-NLS-1$
				"; disposition=" + disposition + //$NON-NLS-1$
				
			    "; serialNumber=" + serialNumber + //$NON-NLS-1$
				"; epcUrn=" + epcUrn + //$NON-NLS-1$
				"; palletTag=" + palletTag + //$NON-NLS-1$
				"; palletUrn=" + palletUrn + //$NON-NLS-1$
				"; caseTag=" + caseTag + //$NON-NLS-1$
				"; caseUrn=" + caseUrn + //$NON-NLS-1$
				"; unitTag=" + unitTag + //$NON-NLS-1$
				"; unitUrn=" + unitUrn + //$NON-NLS-1$
				"; caseCount=" + caseCount + //$NON-NLS-1$
				"; unitCount=" + unitCount + //$NON-NLS-1$
				"; childCount=" + childCount + //$NON-NLS-1$
				"; palletNum=" + palletNum + //$NON-NLS-1$
				"; palletCnt=" + palletCnt + //$NON-NLS-1$
				
				"; orderNumber=" + orderNumber + //$NON-NLS-1$
				"; lastOrderNum=" + lastOrderNum + //$NON-NLS-1$
				
				"; numTagsScanned=" + numTagsScanned +  //$NON-NLS-1$
				"; needTagCounter=" + needTagCounter +  //$NON-NLS-1$
				
    			"; prod_code=" + prod_code +
    			"; prod_name=" + prod_name +
    			"; prod_version=" + prod_version +
    			"; label_type=" + label_type +
    			"; label_display=" + label_display +
    			"; label_updateTime=" + label_updateTime +
    			"; temp_name=" + temp_name +
    			"; temp_version=" + temp_version +
    			"; temp_updateTime=" + temp_updateTime +
    			"; temp_label1=" + temp_label1 +
    			"; temp_label2=" + temp_label2 +
    			"; temp_label3=" + temp_label3 +
    			"; temp_label4=" + temp_label4 +
    			"; temp_label5=" + temp_label5 +
    			"; temp_label6=" + temp_label6 +
    			"; temp_label7=" + temp_label7 +
    			"; temp_label8=" + temp_label8 +
    			"; temp_label9=" + temp_label9 +

    			"; req_url=" + req_url +
    			
				"; displayData=" + displayData + //$NON-NLS-1$
				"; lastError=" + lastError + //$NON-NLS-1$
				
				"; tagList=" + ((tagList == null) ? "null" : Integer.toString(tagList.length)) +   //$NON-NLS-1$//$NON-NLS-2$
				
				"};"; //$NON-NLS-1$

    	return result;
    }
    
    public void reset(ActionMapping mapping, HttpServletRequest request) {
        // Reset values are provided as samples only. Change as appropriate.

    	debug = DEFAULT_DEBUG;
    	station = null;
    	printer = null;
        screen = null;
        command = null;
        message = null;
        userName = null;
        userId = null;
        destinationId = null;
        disposition = null;
        
        serialNumber = null;
        epcUrn = null;
        palletTag = null;
        palletUrn = null;
        caseTag = null;
        caseUrn = null;
        unitTag = null;
        unitUrn = null;
        caseCount = 0;
        unitCount = 0;
        childCount = 0;
        palletNum = 0;
        palletCnt = 0;
        orderNumber = null;
        lastOrderNum = null;
        
     	numTagsScanned = 0;
    	needTagCounter = false;
    	
    	req_url = null;
    	
        displayData = null; 
    	lastError = null;
    	
    	tagList = null;
    }
    
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
    	ActionErrors errors = new ActionErrors();
    	return errors;
    }

	public static boolean isDEFAULT_DEBUG() {
		return DEFAULT_DEBUG;
	}

	public static void setDEFAULT_DEBUG(boolean default_debug) {
		DEFAULT_DEBUG = default_debug;
	}

	public static long getSerialVersionUID() {
		return serialVersionUID;
	}

	public int getCaseCount() {
		return caseCount;
	}

	public void setCaseCount(int caseCount) {
		this.caseCount = caseCount;
	}
	
	public String getCaseTag() {
		return caseTag;
	}

	public void setCaseTag(String caseTag) {
		this.caseTag = caseTag;
	}

	public String getCaseUrn() {
		return caseUrn;
	}

	public void setCaseUrn(String caseUrn) {
		this.caseUrn = caseUrn;
	}

	public int getChildCount() {
		return childCount;
	}

	public void setChildCount(int childCount) {
		this.childCount = childCount;
	}

	public String getCommand() {
		return command;
	}

	public void setCommand(String command) {
		this.command = command;
	}

	public boolean isDebug() {
		return debug;
	}

	public void setDebug(boolean debug) {
		this.debug = debug;
	}

	public String getEpcUrn() {
		return epcUrn;
	}

	public void setEpcUrn(String epcUrn) {
		this.epcUrn = epcUrn;
	}

	public String getLastError() {
		return lastError;
	}

	public void setLastError(String lastError) {
		this.lastError = lastError;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public String getUserName() {
		return userName;
	}

	public void setUserName(String name) {
		this.userName = name;
	}

	public boolean isNeedTagCounter() {
		return needTagCounter;
	}

	public void setNeedTagCounter(boolean needTagCounter) {
		this.needTagCounter = needTagCounter;
	}

	public int getNumTagsScanned() {
		return numTagsScanned;
	}

	public void setNumTagsScanned(int numTagsScanned) {
		this.numTagsScanned = numTagsScanned;
	}

	public String getOrderNumber() {
		return orderNumber;
	}

	public void setOrderNumber(String orderNumber) {
		this.orderNumber = orderNumber;
	}

	public String getPalletTag() {
		return palletTag;
	}

	public void setPalletTag(String palletTag) {
		this.palletTag = palletTag;
	}

	public String getPalletUrn() {
		return palletUrn;
	}

	public void setPalletUrn(String palletUrn) {
		this.palletUrn = palletUrn;
	}

	public String getScreen() {
		return screen;
	}

	public void setScreen(String screen) {
		this.screen = screen;
	}

	public String getSerialNumber() {
		return serialNumber;
	}

	public void setSerialNumber(String serialNumber) {
		this.serialNumber = serialNumber;
	}

	public String getStation() {
		return station;
	}

	public void setStation(String station) {
		this.station = station;
	}

	public String[] getTagList() {
		return tagList;
	}

	public void setTagList(String[] tagList) {
		this.tagList = tagList;
	}

	public int getUnitCount() {
		return unitCount;
	}

	public void setUnitCount(int unitCount) {
		this.unitCount = unitCount;
	}

	public String getUserId() {
		return userId;
	}

	public void setUserId(String userId) {
		this.userId = userId;
	}

	public String getDisplayData() {
		return displayData;
	}

	public void setDisplayData(String displayData) {
		this.displayData = displayData;
	}

	public String getUnitTag() {
		return unitTag;
	}

	public void setUnitTag(String unitTag) {
		this.unitTag = unitTag;
	}

	public String getUnitUrn() {
		return unitUrn;
	}

	public void setUnitUrn(String unitUrn) {
		this.unitUrn = unitUrn;
	}

	public String getDestinationId() {
		return destinationId;
	}

	public void setDestinationId(String destinationId) {
		this.destinationId = destinationId;
	}

	public String getDisposition() {
		return disposition;
	}

	public void setDisposition(String disposition) {
		this.disposition = disposition;
	}

	public int getPalletCnt() {
		return palletCnt;
	}

	public void setPalletCnt(int palletCnt) {
		this.palletCnt = palletCnt;
	}

	public int getPalletNum() {
		return palletNum;
	}

	public void setPalletNum(int palletNum) {
		this.palletNum = palletNum;
	}

	public String getLastOrderNum() {
		return lastOrderNum;
	}

	public void setLastOrderNum(String lastOrderNum) {
		this.lastOrderNum = lastOrderNum;
	}

	public String getLabel_display() {
		return label_display;
	}

	public void setLabel_display(String label_display) {
		this.label_display = label_display;
	}

	public String getLabel_type() {
		return label_type;
	}

	public void setLabel_type(String label_type) {
		this.label_type = label_type;
	}

	public String getLabel_updateTime() {
		return label_updateTime;
	}

	public void setLabel_updateTime(String label_updateTime) {
		this.label_updateTime = label_updateTime;
	}

	public String getProd_code() {
		return prod_code;
	}

	public void setProd_code(String prod_code) {
		this.prod_code = prod_code;
	}

	public String getProd_name() {
		return prod_name;
	}

	public void setProd_name(String prod_name) {
		this.prod_name = prod_name;
	}

	public String getProd_updateTime() {
		return prod_updateTime;
	}

	public void setProd_updateTime(String prod_updateTime) {
		this.prod_updateTime = prod_updateTime;
	}

	public String getProd_version() {
		return prod_version;
	}

	public void setProd_version(String prod_version) {
		this.prod_version = prod_version;
	}

	public String getTemp_label1() {
		return temp_label1;
	}

	public void setTemp_label1(String temp_label1) {
		this.temp_label1 = temp_label1;
	}

	public String getTemp_label2() {
		return temp_label2;
	}

	public void setTemp_label2(String temp_label2) {
		this.temp_label2 = temp_label2;
	}

	public String getTemp_label3() {
		return temp_label3;
	}

	public void setTemp_label3(String temp_label3) {
		this.temp_label3 = temp_label3;
	}

	public String getTemp_label4() {
		return temp_label4;
	}

	public void setTemp_label4(String temp_label4) {
		this.temp_label4 = temp_label4;
	}

	public String getTemp_label5() {
		return temp_label5;
	}

	public void setTemp_label5(String temp_label5) {
		this.temp_label5 = temp_label5;
	}

	public String getTemp_label6() {
		return temp_label6;
	}

	public void setTemp_label6(String temp_label6) {
		this.temp_label6 = temp_label6;
	}

	public String getTemp_label7() {
		return temp_label7;
	}

	public void setTemp_label7(String temp_label7) {
		this.temp_label7 = temp_label7;
	}

	public String getTemp_label8() {
		return temp_label8;
	}

	public void setTemp_label8(String temp_label8) {
		this.temp_label8 = temp_label8;
	}

	public String getTemp_label9() {
		return temp_label9;
	}

	public void setTemp_label9(String temp_label9) {
		this.temp_label9 = temp_label9;
	}

	public String getTemp_name() {
		return temp_name;
	}

	public void setTemp_name(String temp_name) {
		this.temp_name = temp_name;
	}

	public String getTemp_updateTime() {
		return temp_updateTime;
	}

	public void setTemp_updateTime(String temp_updateTime) {
		this.temp_updateTime = temp_updateTime;
	}

	public String getTemp_version() {
		return temp_version;
	}

	public void setTemp_version(String temp_version) {
		this.temp_version = temp_version;
	}

	public String getPrinter() {
		return printer;
	}

	public void setPrinter(String printer) {
		this.printer = printer;
	}

	public String getReq_url() {
		return req_url;
	}

	public void setReq_url(String req_url) {
		this.req_url = req_url;
	}

	public String getBizLocation() {
		return bizLocation;
	}

	public void setBizLocation(String bizLocation) {
		this.bizLocation = bizLocation;
	}

	public String getTimeZoneOffset() {
		return timeZoneOffset;
	}

	public void setTimeZoneOffset(String timeZoneOffset) {
		this.timeZoneOffset = timeZoneOffset;
	}

	
}
