package com.ibm.trackntrace.usecases.data;

import java.util.ArrayList;

/**
 * @author Sudhir Pucha
 * This class defines an Order ( Purchase Order/ Transfer Order etc).
 * Each PalletInfo object is associated with a Order Info object.
 * Each OrderInfo object is associated with multiple palletInfo objects.
 *
 */
public class OrderInfo {
	
	public OrderInfo( String id){
		orderID = id;
		expectedPalletEPCs = new ArrayList<String>();
		receivedPalletEPCs = new ArrayList<String>();
	}
	
	public OrderInfo(){
		orderID = null;
		expectedPalletEPCs = new ArrayList<String>();
		receivedPalletEPCs = new ArrayList<String>();
	}
	
	/**
	 * Order ID, uniquely identifies the order
	 */
	String orderID = null;
	
	/**
	 * pallet EPCs expected as part of the order
	 */
	ArrayList<String> expectedPalletEPCs = null;
	
	/**
	 * Pallets received so far.
	 */
	
	ArrayList<String> receivedPalletEPCs = null;

	/**
	 * @return
	 */
	public ArrayList<String> getExpectedPalletEPCs() {
		return expectedPalletEPCs;
	}

	/**
	 * @param expectedPalletEPCs
	 */
	public void setExpectedPalletEPCs(ArrayList<String> expectedPalletEPCs) {
		this.expectedPalletEPCs = expectedPalletEPCs;
	}

	/**
	 * @return
	 */
	public String getOrderID() {
		return orderID;
	}

	/**
	 * @param orderID
	 */
	public void setOrderID(String orderID) {
		this.orderID = orderID;
	}

	public ArrayList<String> getReceivedPalletEPCs() {
		return receivedPalletEPCs;
	}

	public void setReceivedPalletEPCs(ArrayList<String> receivedPalletEPCs) {
		this.receivedPalletEPCs = receivedPalletEPCs;
	}

	
}
