package com.ibm.trackntrace.usecases.util;


import com.ibm.premises.reusable.aggregation.Aggregation;
import com.ibm.premises.reusable.aggregation.AggregationHome;
import com.ibm.premises.reusable.backend.BackendIntegration;
import com.ibm.premises.reusable.backend.BackendIntegrationHome;
import com.ibm.premises.reusable.commissioning.Commissioning;
import com.ibm.premises.reusable.commissioning.CommissioningHome;
import com.ibm.premises.reusable.decommissioning.Decommissioning;
import com.ibm.premises.reusable.decommissioning.DecommissioningHome;
import com.ibm.premises.reusable.disaggregation.Disaggregation;
import com.ibm.premises.reusable.disaggregation.DisaggregationHome;
import com.ibm.premises.reusable.epc.EPC;
import com.ibm.premises.reusable.epc.EPCHome;
import com.ibm.premises.reusable.inference.Inference;
import com.ibm.premises.reusable.inference.InferenceHome;
import com.ibm.premises.reusable.info.Info;
import com.ibm.premises.reusable.info.InfoHome;
import com.ibm.premises.reusable.locating.Locating;
import com.ibm.premises.reusable.locating.LocatingHome;
import com.ibm.premises.reusable.observation.Observation;
import com.ibm.premises.reusable.observation.ObservationHome;
import com.ibm.premises.reusable.printing.Printing;
import com.ibm.premises.reusable.printing.PrintingHome;
import com.ibm.premises.reusable.reporting.Reporting;
import com.ibm.premises.reusable.reporting.ReportingHome;
import com.ibm.premises.reusable.validation.Validation;
import com.ibm.premises.reusable.validation.ValidationHome;

public class RUCLocator {

	public static BackendIntegration getBackendBean() throws Exception {
		BackendIntegrationHome backendHome = (BackendIntegrationHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/backend/BackendIntegrationHome", BackendIntegrationHome.class);
		return backendHome.create();
	}
	
	public static EPC getEPCRUC() throws Exception {
		EPCHome rucHome = (EPCHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/epc/EPCHome", EPCHome.class);
		return rucHome.create();
	}
	
	public static Printing getPrintingRUC() throws Exception {
		PrintingHome rucHome = (PrintingHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/printing/PrintingHome", PrintingHome.class);
		return rucHome.create();
	}
	
	public static Commissioning getCommissioningRUC() throws Exception {
		CommissioningHome rucHome = (CommissioningHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/commissioning/CommissioningHome", CommissioningHome.class);
		return rucHome.create();
	}
	public static Decommissioning getDecommissioningRUC() throws Exception {
		DecommissioningHome rucHome = (DecommissioningHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/decommissioning/DecommissioningHome", DecommissioningHome.class);
		return rucHome.create();
	}
	public static Locating getLocatingRUC() throws Exception {
		LocatingHome rucHome = (LocatingHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/locating/LocatingHome", LocatingHome.class);
		return rucHome.create();
	}
	public static Reporting getReportingRUC() throws Exception {
		ReportingHome rucHome = (ReportingHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/reporting/ReportingHome", ReportingHome.class);
		return rucHome.create();
	}
	public static Observation getObservationRUC() throws Exception {
		ObservationHome rucHome = (ObservationHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/observation/ObservationHome", ObservationHome.class);
		return rucHome.create();
	}
	
	public static Validation getValidationRUC() throws Exception {
		ValidationHome rucHome = (ValidationHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/validation/ValidationHome", ValidationHome.class);
		return rucHome.create();
	}
	
	public static Aggregation getAggregationRUC() throws Exception {
		AggregationHome rucHome = (AggregationHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/aggregation/AggregationHome", AggregationHome.class);
		return rucHome.create();
	}
	
	public static Disaggregation getDisaggregationRUC() throws Exception {
		DisaggregationHome rucHome = (DisaggregationHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/disaggregation/DisaggregationHome", DisaggregationHome.class);
		return rucHome.create();
	}	
	public static Inference getInferenceRUC() throws Exception {
		InferenceHome rucHome = (InferenceHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/inference/InferenceHome", InferenceHome.class);
		return rucHome.create();
	}	
	public static Info getInfoRUC() throws Exception {
		InfoHome rucHome = (InfoHome) ResourceLocator.singleton().getEJBHome("ejb/com/ibm/premises/reusable/info/InfoHome", InfoHome.class);
		return rucHome.create();
	}	
	
}
