package com.ibm.trackntrace.utils;

import java.util.logging.Logger;
import javax.servlet.http.HttpServletRequest;

public class RoleValidation {
	private static final Logger log;
	static {
		log = Logger.getLogger("Constants.LOG_ROLEVAL");
	}
	
	public static final int SUCCESS = 0;
	public static final int INVALID_USER = 1;
	public static final int UNAUTHORIZED_USER = 2;
	
	private static final boolean security_on = false; // TODO: remove for production - false will allow testing under RAD
	
	public static boolean validate (HttpServletRequest req, String role) {
		boolean result = false;
		log.entering(RoleValidation.class.getName(), "validate(role=" + role + ")");
		
		if (security_on == false) {
			result = true;
		} else if (role == RoleDefs.ANY) {
			for (int i=0; i<RoleDefs.allRoles.length; i++) {
				if (req.isUserInRole(RoleDefs.allRoles[i]) == true) {
					result = true;
					break;
				}
			}
		} else if (req.isUserInRole(role)) {
			result = true;
		} 
		
		log.exiting(RoleValidation.class.getName(), "validate result=" + result);
		return result;
	}

}
